<template>
  <v-app>
    <Menu/>
    <v-layout row wrap>
      <LeftSidebar/>
      <v-flex xs12 sm8 class="editor">
        <v-form v-model="valid" ref="form">
          <v-text-field
            label="Название заметки"
            placeholder="Введите текст"
            :rules="rules"
            required
            v-model="title"
            outline
          ></v-text-field>
          <Editor v-model="message" label="Текст вашей заметки"/>
          <v-btn @click="submit">Опубликовать</v-btn>
        </v-form>
      </v-flex>
    </v-layout>
  </v-app>
</template>

<script>
  import Editor from "@servicestack/editor";
  import Menu from '../components/Menu'
  import LeftSidebar from '../components/LeftSidebar'


  export default {
    beforeRouteEnter(to, from, next) {
      // check user permissions
      next(vm => {
        let userProfile = JSON.parse(localStorage.getItem('profileStorage'))
        if (userProfile === null) {
          vm.$router.push('/login')
        }
      })
    },
    components: {
      Menu,
      LeftSidebar,
      Editor
    },
    data() {
      return {
        rules: [
          (v) => !!v || 'Введите название',
        ],
        title: null,
        message: '',
        valid: false,
        userProfile: null
      }
    },
    created() {
      this.$store.dispatch('getProfile')
        .then(() => {
          let profile = localStorage.getItem('profileStorage')
          this.userProfile = JSON.parse(profile)
        })
    },
    methods: {
      submit() {
        if (this.$refs.form.validate()) {
          let title = this.title
          let text = this.message
          let author = this.userProfile.id

          this.$store.dispatch('createPost', {title, text, author})
            .then(() => this.$router.push({name: 'dashboard'}))
            .catch(e => {
              console.log(e)
            })
        }
      }
    }
  }
</script>

<style lang="scss" scoped>
  .editor {
    padding-top: 20px;
  }

</style>
